/* 
 * File:   Canvas.cpp
 * Author: Michael
 * 
 * Created on 21 August 2015, 15:44
 */

#include "Canvas.h"
#include "Background_jpeg.h"
#include "Body_jpeg.h"
#include "Body_Sideways_jpeg.h"
#include "Food_jpeg.h"
#include "Head_png.h"
#include "Head_Down_png.h"
#include "Head_Left_png.h"
#include "Head_Right_png.h"
using namespace std;

Canvas::Canvas() {
   
    tex1 = sfil_load_JPEG_buffer(Background_jpeg, Background_jpeg_size, SF2D_PLACE_RAM);
    tex2 = sfil_load_JPEG_buffer(Food_jpeg, Food_jpeg_size, SF2D_PLACE_RAM);
    tex3 = sfil_load_JPEG_buffer(Body_jpeg, Body_jpeg_size, SF2D_PLACE_RAM);
    tex4 = sfil_load_JPEG_buffer(Body_Sideways_jpeg, Body_Sideways_jpeg_size,SF2D_PLACE_RAM);
    tex5 = sfil_load_PNG_buffer(Head_png, SF2D_PLACE_RAM);
    tex6 = sfil_load_PNG_buffer(Head_Down_png, SF2D_PLACE_RAM);
    tex7 = sfil_load_PNG_buffer(Head_Left_png, SF2D_PLACE_RAM);
    tex8 = sfil_load_PNG_buffer(Head_Right_png, SF2D_PLACE_RAM);
    
    drawState = false;
    GameOver = false;
    newScore = false;
    
    
    

}


void Canvas::draw(List CoordinateList) {
    sf2d_init();
    //consoleClear();
    NodeList = CoordinateList;
    consoleInit(GFX_BOTTOM, &BottomScreen);
    printf("\x1b[15;11H");
    printf("\x1b[32mTHE REAL SNAKE 3DS");
    printf("\x1b[1;0H");
        printf("\x1b[32mCurrent Score: ");
        printf("%.0f", Score);
        printf("\n");
        if(newScore)
        {
            printf("\x1b[31mNEW Highscore: ");
        }
        else
        {
            printf("\x1b[32mHighscore: ");
        }
        
        printf("%.0f", Highscore);
    
    if(drawState)
    {
         sf2d_start_frame(GFX_TOP, GFX_LEFT);
        sf2d_draw_texture(tex1, 0, 0);   
        sf2d_draw_line(5,5,395,5, RGBA8(0x00,0x00,0x00,0xFF));
        sf2d_draw_line(5,5,5,235, RGBA8(0x00,0x00,0x00,0xFF));
        sf2d_draw_line(5,235,395,235, RGBA8(0x00,0x00,0x00,0xFF));
        sf2d_draw_line(395,5,395,235, RGBA8(0x00,0x00,0x00,0xFF));
        
        
        Node *p = CoordinateList.Head;
        
        switch(p->dir)
        {
            case ('u'):
                    sf2d_draw_texture(tex5, p->getContent().getX(), p->getContent().getY());
                    break;
            case ('d'):
                    sf2d_draw_texture(tex6, p->getContent().getX(), p->getContent().getY());
                    break;
            case ('l'):
                    sf2d_draw_texture(tex7, p->getContent().getX(), p->getContent().getY());
                    break;
            case ('r'):
                    sf2d_draw_texture(tex8, p->getContent().getX(), p->getContent().getY());
                    break;
                
        }
        
        if(p->next != NULL)
        {
            p = p->next;
        }
        while(p!=NULL)
        {
           
            switch(p->dir)
            {
                case 'u':
                sf2d_draw_texture(tex3, p->getContent().getX(), p->getContent().getY());
                break;
                case 'd':
                sf2d_draw_texture(tex3, p->getContent().getX(), p->getContent().getY());
                break;
                case 'l':
                sf2d_draw_texture(tex4, p->getContent().getX(), p->getContent().getY());
                break;
                case 'r':
                sf2d_draw_texture(tex4, p->getContent().getX(), p->getContent().getY());
                break;
            }
            
            p = p->next;
        }
        
        sf2d_draw_texture(tex2, Tx, Ty);
        sf2d_end_frame();
        
        
        sf2d_swapbuffers();
        
        

        
    }
    else{
        if(GameOver)
    {
        printf("\x1b[16;15H");
        printf("\x1b[32mGame Over!\n");
        printf("\x1b[17;7H");
        printf("\x1b[32mPress Start to try again.\n");

        
      
    }
       
        
        
    
    }
   
        
        
        if(GameOver)
        {
            sf2d_fini();
        }
       
   
}

void Canvas::drawToken(int x, int y)
{
    Tx = x;
    Ty = y;
    
}

void Canvas::kill()
{
    sf2d_fini();
    sf2d_free_texture(tex1);
    sf2d_free_texture(tex2);
    sf2d_free_texture(tex3);
    sf2d_free_texture(tex4);
    sf2d_free_texture(tex5);
    sf2d_free_texture(tex6);
    sf2d_free_texture(tex7);
    sf2d_free_texture(tex8);
    
}
