/* 
 * File:   main.c
 * Author: Michael
 *
 * Created on 4. Juli 2015, 21:52
 */


//Variables


#include "Game.h"


//Methods
using namespace std;
	
//Top Screen: 30 rows, 50 columns
//Bottom Screen: 30 rows, 40 columns

/*
 * 
 */
Game::Game() {
    
    
   


}

void Game::init()
{
    sf2d_init();
    status = true; 
    
    consoleInit(GFX_TOP, &TopScreen);

    
    consoleSelect(&TopScreen);
    printf("\x1b[14;16H");
    printf("\x1b[32mTHE REAL SNAKE3DS");
    printf("\x1b[29;15H");
    printf("\x1b[32;47mPress Start to begin");
    GameRunning = false;
    List snake;
    
    u32 kDown;
    while(true)
    {
        hidScanInput();
        kDown = hidKeysDown();

        
        
        if(kDown == KEY_START)
        {
            
            sf2d_fini();
            StartGame();
            break;
               
            
            
        }
        if(aptGetStatus()==APP_SUSPENDING)
            {
                aptReturnToMenu();
                
            }
    }
}
Game::~Game()
{
    status = false;
    
    widget->kill();
    
}



void Game::StartGame()
{
    sf2d_fini();
    FILE *file = fopen("data.bin", "r");
    if(file == NULL) 
    {
        file = fopen("data.bin", "w");
        fprintf(file, "%.0f", 0.0);
    }
    
    fscanf(file, "%f.1", &Highscore);
    fclose(file);
    Score = 0.0;
    widget = new Canvas();
    widget->setScore(Score);
    widget->setHighscore(Highscore);
    snake.clear();
    snake.attach(195,115, 'u');
    snake.attach(195,125, 'u');
    widget->drawState=true;
    DrawToken();
    widget->draw(snake.getCoordinates());
    GameRunning = true;


    while(status)
    {
        
        hidScanInput();
        u32 keyDown = hidKeysDown();
        
        
        if(GameRunning)
        {
           
        if(!pause)
        {   
            last_dir = dir;
        }
        switch(keyDown)
        {
            case KEY_DUP:
                if(last_dir!='d')
                {
                    lock = true;
                    next_dir = 'u';
                    pause = false;
                    
                }
            break;
            
            
            
            case KEY_DDOWN:
                    if(last_dir != 'u')
                    {
                        lock = true;
                        next_dir = 'd';  
                        pause = false;
                    }
            break;
            
            case KEY_DLEFT:
                if(last_dir!='r')
                {
                    lock = true;
                    next_dir = 'l';               
                    pause = false;
                }
            break;
            
            case KEY_DRIGHT:
                    if(last_dir != 'l')
                    {
                        lock = true;
                        next_dir = 'r';
                        pause = false;
                    }
                
            break;
            
            case KEY_CPAD_UP:
                if(last_dir!='d')
                {
                    lock = true;
                    next_dir = 'u';
                    pause = false;
                }
                
            break;
            
            
            
            case KEY_CPAD_DOWN:
                    if(last_dir != 'u')
                    {
                        lock = true;
                        next_dir = 'd';
                        pause = false;
                    }
                
            break;
            
            case KEY_CPAD_LEFT:
                if(last_dir!='r')
                {
                    lock = true;
                    next_dir = 'l';
                    pause = false;
                }
                
            break;
            
            case KEY_CPAD_RIGHT:
                    if(last_dir != 'l')
                    {
                        lock = true;
                        next_dir = 'r';
                        pause = false;
                    }
                
            break;
            
            case KEY_START+KEY_SELECT:
                status = false;
                 
            break;
            
            case KEY_START:
                last_dir = dir;
                next_dir = NULL;
                pause = true;
                break;
                
            
            
        }
        
        
        }
        
        if(widget->GameOver)
        {
            if(keyDown == KEY_START)
            {
               
                
                break;
                
            }
            
            if(keyDown == KEY_START + KEY_SELECT)
            {
                status = false;
            }
        }
        
    }
    
    
    if(aptGetStatus()==APP_SUSPENDING)
            {
                aptReturnToMenu();
                
            }
    
   
    if(status)
    {
        widget->GameOver=false;
                StartGame();
    }
    else{
       
       
    }
}

void Game::GameOverCheck()
{

    if(TokenCheck())
    {
        snake.attach(snake.Head->getContent().getX(),snake.Head->getContent().getY(), dir);
        DrawToken();

    }



    if(snake.GameOverCheck())
    {
        Score = 0;
        widget->setScore(0);
        GameRunning = false;
        widget->drawState=false;
        widget->GameOver=true;
        dir = NULL;
        next_dir = NULL;
        widget->draw(snake.getCoordinates());
        
        
        
        

    }
}

void Game::moveSnake()
{
    
//    if(!lock)
//    {
        dir = next_dir;
        snake.Head->dir = dir;
//    }
    if(GameRunning)
    {
       
        switch(dir)
        {
        case 'u':
            snake.Head->move('u');
            GameOverCheck();
            widget->draw(snake.getCoordinates());
            break;
        case 'd':
            snake.Head->move('d');
            GameOverCheck();
            widget->draw(snake.getCoordinates());
            break;
        case 'l':
            snake.Head->move('l');
            GameOverCheck();
            widget->draw(snake.getCoordinates());
            break;
        case 'r':
            snake.Head->move('r');
            GameOverCheck();
            widget->draw(snake.getCoordinates());
            break;

        }
        
        
        

    }


}

void Game::DrawToken()
{
    srand(osGetTime());
    int x = (((rand()%39+1)*10))-5;
    int y = (((rand()%23+1)*10))-5;
    if(snake.contains(x,y))
    {
        DrawToken();
    }
    else
    {
        widget->drawToken(x,y);
        widget->draw(snake.getCoordinates());
    }
    
   
}

bool Game::TokenCheck()
{
    if(snake.Head->getContent().getX() == widget->Tx && snake.Head->getContent().getY() == widget->Ty)
    {
        setScore();
        return true;
    }
    else
    {
        eaten();
        return false;
    }
}

void Game::eaten()
{
    if(snake.Cannibal())
    {
        GameRunning = false;
        widget->drawState=false;
        widget->GameOver=true;
        dir = NULL;
        next_dir = NULL;
        widget->draw(snake.getCoordinates());
    }
}

void Game::setScore()
{
    Score = Score + 100;
    widget->setScore(Score);
    if(Score > Highscore)
    {

        widget->setNewScore();
        Highscore = Score;
        widget->setHighscore(Highscore);
        FILE *file = fopen("data.bin", "w");
        fprintf(file, "%.0f", Highscore);
        fclose(file);
        
    }
}
